/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_COMMON_COMMON_DEFINES_HPP_
#define V1_COMMONAPI_TELUX_COMMON_COMMON_DEFINES_HPP_




#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Types.hpp>
#include <cstdint>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace common {

class CommonDefines {
public:
    virtual ~CommonDefines() { }

    static inline const char* getInterface();
    static inline CommonAPI::Version getInterfaceVersion();
    
    struct Status : CommonAPI::Enumeration< int32_t> {
        enum Literal : int32_t {
            SUCCESS = 0,
            FAILED = 1,
            NOCONNECTION = 2,
            NOSUBSCRIPTION = 3,
            INVALIDPARAM = 4,
            INVALIDSTATE = 5,
            NOTREADY = 6,
            NOTALLOWED = 7,
            NOTIMPLEMENTED = 8,
            CONNECTIONLOST = 9,
            EXPIRED = 10,
            ALREADY = 11,
            NOSUCH = 12,
            NOTSUPPORTED = 13,
            NOMEMORY = 14
        };
    
        Status()
            : CommonAPI::Enumeration< int32_t>(static_cast< int32_t>(Literal::SUCCESS)) {}
        Status(Literal _literal)
            : CommonAPI::Enumeration< int32_t>(static_cast< int32_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< int32_t>(Literal::SUCCESS):
                case static_cast< int32_t>(Literal::FAILED):
                case static_cast< int32_t>(Literal::NOCONNECTION):
                case static_cast< int32_t>(Literal::NOSUBSCRIPTION):
                case static_cast< int32_t>(Literal::INVALIDPARAM):
                case static_cast< int32_t>(Literal::INVALIDSTATE):
                case static_cast< int32_t>(Literal::NOTREADY):
                case static_cast< int32_t>(Literal::NOTALLOWED):
                case static_cast< int32_t>(Literal::NOTIMPLEMENTED):
                case static_cast< int32_t>(Literal::CONNECTIONLOST):
                case static_cast< int32_t>(Literal::EXPIRED):
                case static_cast< int32_t>(Literal::ALREADY):
                case static_cast< int32_t>(Literal::NOSUCH):
                case static_cast< int32_t>(Literal::NOTSUPPORTED):
                case static_cast< int32_t>(Literal::NOMEMORY):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const Status &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const Status &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const Status &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const Status &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const Status &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const Status &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< int32_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< int32_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< int32_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< int32_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< int32_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< int32_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< int32_t>(Literal::SUCCESS): return "SUCCESS";
            case static_cast< int32_t>(Literal::FAILED): return "FAILED";
            case static_cast< int32_t>(Literal::NOCONNECTION): return "NOCONNECTION";
            case static_cast< int32_t>(Literal::NOSUBSCRIPTION): return "NOSUBSCRIPTION";
            case static_cast< int32_t>(Literal::INVALIDPARAM): return "INVALIDPARAM";
            case static_cast< int32_t>(Literal::INVALIDSTATE): return "INVALIDSTATE";
            case static_cast< int32_t>(Literal::NOTREADY): return "NOTREADY";
            case static_cast< int32_t>(Literal::NOTALLOWED): return "NOTALLOWED";
            case static_cast< int32_t>(Literal::NOTIMPLEMENTED): return "NOTIMPLEMENTED";
            case static_cast< int32_t>(Literal::CONNECTIONLOST): return "CONNECTIONLOST";
            case static_cast< int32_t>(Literal::EXPIRED): return "EXPIRED";
            case static_cast< int32_t>(Literal::ALREADY): return "ALREADY";
            case static_cast< int32_t>(Literal::NOSUCH): return "NOSUCH";
            case static_cast< int32_t>(Literal::NOTSUPPORTED): return "NOTSUPPORTED";
            case static_cast< int32_t>(Literal::NOMEMORY): return "NOMEMORY";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct ErrorCode : CommonAPI::Enumeration< int32_t> {
        enum Literal : int32_t {
            SUCCESS = 0,
            RADIO_NOT_AVAILABLE = 1,
            GENERIC_FAILURE = 2,
            PASSWORD_INCORRECT = 3,
            SIM_PIN2 = 4,
            SIM_PUK2 = 5,
            REQUEST_NOT_SUPPORTED = 6,
            CANCELLED = 7,
            OP_NOT_ALLOWED_DURING_VOICE_CALL = 8,
            OP_NOT_ALLOWED_BEFORE_REG_TO_NW = 9,
            SMS_SEND_FAIL_RETRY = 10,
            SIM_ABSENT = 11,
            SUBSCRIPTION_NOT_AVAILABLE = 12,
            MODE_NOT_SUPPORTED = 13,
            FDN_CHECK_FAILURE = 14,
            ILLEGAL_SIM_OR_ME = 15,
            MISSING_RESOURCE = 16,
            NO_SUCH_ELEMENT = 17,
            DIAL_MODIFIED_TO_USSD = 18,
            DIAL_MODIFIED_TO_SS = 19,
            DIAL_MODIFIED_TO_DIAL = 20,
            USSD_MODIFIED_TO_DIAL = 21,
            USSD_MODIFIED_TO_SS = 22,
            USSD_MODIFIED_TO_USSD = 23,
            SS_MODIFIED_TO_DIAL = 24,
            SS_MODIFIED_TO_USSD = 25,
            SUBSCRIPTION_NOT_SUPPORTED = 26,
            SS_MODIFIED_TO_SS = 27,
            LCE_NOT_SUPPORTED = 36,
            NO_MEMORY = 37,
            INTERNAL_ERR = 38,
            SYSTEM_ERR = 39,
            MODEM_ERR = 40,
            INVALID_STATE = 41,
            NO_RESOURCES = 42,
            SIM_ERR = 43,
            INVALID_ARGUMENTS = 44,
            INVALID_SIM_STATE = 45,
            INVALID_MODEM_STATE = 46,
            INVALID_CALL_ID = 47,
            NO_SMS_TO_ACK = 48,
            NETWORK_ERR = 49,
            REQUEST_RATE_LIMITED = 50,
            SIM_BUSY = 51,
            SIM_FULL = 52,
            NETWORK_REJECT = 53,
            OPERATION_NOT_ALLOWED = 54,
            EMPTY_RECORD = 55,
            INVALID_SMS_FORMAT = 56,
            ENCODING_ERR = 57,
            INVALID_SMSC_ADDRESS = 58,
            NO_SUCH_ENTRY = 59,
            NETWORK_NOT_READY = 60,
            NOT_PROVISIONED = 61,
            NO_SUBSCRIPTION = 62,
            NO_NETWORK_FOUND = 63,
            DEVICE_IN_USE = 64,
            ABORTED = 65,
            INCOMPATIBLE_STATE = 90,
            NO_EFFECT = 101,
            DEVICE_NOT_READY = 102,
            MISSING_ARGUMENTS = 103,
            PIN_PERM_BLOCKED = 201,
            PIN_BLOCKED = 202,
            MALFORMED_MSG = 1001,
            INTERNAL = 1003,
            CLIENT_IDS_EXHAUSTED = 1005,
            UNABORTABLE_TRANSACTION = 1006,
            INVALID_CLIENT_ID = 1007,
            NO_THRESHOLDS = 1008,
            INVALID_HANDLE = 1009,
            INVALID_PROFILE = 1010,
            INVALID_PINID = 1011,
            INCORRECT_PIN = 1012,
            CALL_FAILED = 1014,
            OUT_OF_CALL = 1015,
            MISSING_ARG = 1017,
            ARG_TOO_LONG = 1019,
            INVALID_TX_ID = 1022,
            OP_NETWORK_UNSUPPORTED = 1024,
            OP_DEVICE_UNSUPPORTED = 1025,
            NO_FREE_PROFILE = 1027,
            INVALID_PDP_TYPE = 1028,
            INVALID_TECH_PREF = 1029,
            INVALID_PROFILE_TYPE = 1030,
            INVALID_SERVICE_TYPE = 1031,
            INVALID_REGISTER_ACTION = 1032,
            INVALID_PS_ATTACH_ACTION = 1033,
            AUTHENTICATION_FAILED = 1034,
            SIM_NOT_INITIALIZED = 1037,
            MAX_QOS_REQUESTS_IN_USE = 1038,
            INCORRECT_FLOW_FILTER = 1039,
            NETWORK_QOS_UNAWARE = 1040,
            INVALID_ID = 1041,
            REQUESTED_NUM_UNSUPPORTED = 1042,
            INTERFACE_NOT_FOUND = 1043,
            FLOW_SUSPENDED = 1044,
            INVALID_DATA_FORMAT = 1045,
            GENERAL = 1046,
            UNKNOWN = 1047,
            INVALID_ARG = 1048,
            INVALID_INDEX = 1049,
            NO_ENTRY = 1050,
            DEVICE_STORAGE_FULL = 1051,
            CAUSE_CODE = 1054,
            MESSAGE_NOT_SENT = 1055,
            MESSAGE_DELIVERY_FAILURE = 1056,
            INVALID_MESSAGE_ID = 1057,
            ENCODING = 1058,
            AUTHENTICATION_LOCK = 1059,
            INVALID_TRANSITION = 1060,
            NOT_A_MCAST_IFACE = 1061,
            MAX_MCAST_REQUESTS_IN_USE = 1062,
            INVALID_MCAST_HANDLE = 1063,
            INVALID_IP_FAMILY_PREF = 1064,
            SESSION_INACTIVE = 1065,
            SESSION_INVALID = 1066,
            SESSION_OWNERSHIP = 1067,
            INSUFFICIENT_RESOURCES = 1068,
            DISABLED = 1069,
            INVALID_OPERATION = 1070,
            INVALID_QMI_CMD = 1071,
            TPDU_TYPE = 1072,
            SMSC_ADDR = 1073,
            INFO_UNAVAILABLE = 1074,
            SEGMENT_TOO_LONG = 1075,
            SEGMENT_ORDER = 1076,
            BUNDLING_NOT_SUPPORTED = 1077,
            OP_PARTIAL_FAILURE = 1078,
            POLICY_MISMATCH = 1079,
            SIM_FILE_NOT_FOUND = 1080,
            EXTENDED_INTERNAL = 1081,
            ACCESS_DENIED = 1082,
            HARDWARE_RESTRICTED = 1083,
            ACK_NOT_SENT = 1084,
            INJECT_TIMEOUT = 1085,
            FDN_RESTRICT = 1091,
            SUPS_FAILURE_CAUSE = 1092,
            NO_RADIO = 1093,
            NOT_SUPPORTED = 1094,
            CARD_CALL_CONTROL_FAILED = 1096,
            NETWORK_ABORTED = 1097,
            MSG_BLOCKED = 1098,
            INVALID_SESSION_TYPE = 1100,
            INVALID_PB_TYPE = 1101,
            NO_SIM = 1102,
            PB_NOT_READY = 1103,
            PIN_RESTRICTION = 1104,
            PIN2_RESTRICTION = 1105,
            PUK_RESTRICTION = 1106,
            PUK2_RESTRICTION = 1107,
            PB_ACCESS_RESTRICTED = 1108,
            PB_DELETE_IN_PROG = 1109,
            PB_TEXT_TOO_LONG = 1110,
            PB_NUMBER_TOO_LONG = 1111,
            PB_HIDDEN_KEY_RESTRICTION = 1112,
            PB_NOT_AVAILABLE = 1113,
            DEVICE_MEMORY_ERROR = 1114,
            NO_PERMISSION = 1115,
            TOO_SOON = 1116,
            TIME_NOT_ACQUIRED = 1117,
            OP_IN_PROGRESS = 1118,
            DS_PROFILE_REG_RESULT_FAIL = 2001,
            DS_PROFILE_REG_RESULT_ERR_INVAL_HNDL = 2002,
            DS_PROFILE_REG_RESULT_ERR_INVAL_OP = 2003,
            DS_PROFILE_REG_RESULT_ERR_INVAL_PROFILE_TYPE = 2004,
            DS_PROFILE_REG_RESULT_ERR_INVAL_PROFILE_NUM = 2005,
            DS_PROFILE_REG_RESULT_ERR_INVAL_IDENT = 2006,
            DS_PROFILE_REG_RESULT_ERR_INVAL = 2007,
            DS_PROFILE_REG_RESULT_ERR_LIB_NOT_INITED = 2008,
            DS_PROFILE_REG_RESULT_ERR_LEN_INVALID = 2009,
            DS_PROFILE_REG_RESULT_LIST_END = 2010,
            DS_PROFILE_REG_RESULT_ERR_INVAL_SUBS_ID = 2011,
            DS_PROFILE_REG_INVAL_PROFILE_FAMILY = 2012,
            DS_PROFILE_REG_PROFILE_VERSION_MISMATCH = 2013,
            REG_RESULT_ERR_OUT_OF_MEMORY = 2014,
            DS_PROFILE_REG_RESULT_ERR_FILE_ACCESS = 2015,
            DS_PROFILE_REG_RESULT_ERR_EOF = 2016,
            REG_RESULT_ERR_VALID_FLAG_NOT_SET = 2017,
            REG_RESULT_ERR_OUT_OF_PROFILES = 2018,
            REG_RESULT_NO_EMERGENCY_PDN_SUPPORT = 2019,
            V2X_ERR_EXCEED_MAX = 3000,
            V2X_ERR_V2X_DISABLED = 3001,
            V2X_ERR_UNKNOWN_SERVICE_ID = 3002,
            V2X_ERR_SRV_ID_L2_ADDRS_NOT_COMPATIBLE = 3003,
            V2X_ERR_PORT_UNAVAIL = 3004,
            DS_PROFILE_3GPP_INVAL_PROFILE_FAMILY = 4097,
            DS_PROFILE_3GPP_ACCESS_ERR = 4098,
            DS_PROFILE_3GPP_CONTEXT_NOT_DEFINED = 4099,
            DS_PROFILE_3GPP_VALID_FLAG_NOT_SET = 4100,
            DS_PROFILE_3GPP_READ_ONLY_FLAG_SET = 4101,
            DS_PROFILE_3GPP_ERR_OUT_OF_PROFILES = 4102,
            DS_PROFILE_3GPP2_ERR_INVALID_IDENT_FOR_PROFILE = 4353,
            DS_PROFILE_3GPP2_ERR_OUT_OF_PROFILE = 4354,
            INTERNAL_ERROR = -1,
            SERVICE_ERROR = -2,
            TIMEOUT_ERROR = -3,
            EXTENDED_ERROR = -4,
            PORT_NOT_OPEN_ERROR = -5,
            MEMCOPY_ERROR = -13,
            INVALID_TRANSACTION = -14,
            ALLOCATION_FAILURE = -15,
            TRANSPORT_ERROR = -16,
            PARAM_ERROR = -17,
            INVALID_CLIENT = -18,
            FRAMEWORK_NOT_READY = -19,
            INVALID_SIGNAL = -20,
            TRANSPORT_BUSY_ERROR = -21,
            SUBSYSTEM_UNAVAILABLE = 5000,
            OPERATION_TIMEOUT = 5001,
            ROLLBACK_FAILED = 5002,
            ROT_ALREADY_SET = 5003,
            UNSUPPORTED_PURPOSE = 5004,
            INCOMPATIBLE_PURPOSE = 5005,
            UNSUPPORTED_ALGO = 5006,
            INCOMPATIBLE_ALGO = 5007,
            UNSUPPORTED_KEY_SIZE = 5008,
            UNSUPPORTED_BLOCK_MODE = 5009,
            INCOMPATIBLE_BLOCK_MODE = 5010,
            UNSUPPORTED_MAC_LEN = 5011,
            UNSUPPORTED_PADDING_MODE = 5012,
            UNSUPPORTED_DIGEST = 5013,
            INCOMPATIBLE_DIGEST = 5014,
            INVAL_EXP_TIME = 5015,
            INVAL_USR_ID = 5016,
            INVAL_AUTH_TIMEOUT = 5017,
            UNSUPPORTED_KEY_FMT = 5018,
            INCOMPATIBLE_KEY_FMT = 5019,
            UNSUPPORTED_KEY_ENC_ALGO = 5020,
            UNSUPPORTED_KEY_VRFY_ALGO = 5021,
            INVAL_IN_LEN = 5022,
            INVAL_KEY_EXPRT_OPTNS = 5023,
            DELEGATION_NOT_ALLOWED = 5024,
            KEY_NOT_YET_VALID = 5025,
            KEY_EXPIRED = 5026,
            KEY_USR_NOT_AUTHENTICATED = 5027,
            OUT_PARAMETER_NULL = 5028,
            INVAL_OPERATION_HNDL = 5029,
            INSUFFICIENT_BUF_SPACE = 5030,
            VERIFICATION_FAILED = 5031,
            TOO_MANY_OPS = 5032,
            UNEXPECTED_NULL_PTR = 5033,
            INVAL_KEY_BLOB = 5034,
            IMPORTED_KEY_NOT_ENC = 5035,
            IMPORTED_KEY_DEC_FAIL = 5036,
            IMPORTED_KEY_NOT_SIGNED = 5037,
            IMPORTED_KEY_VRFY_FAIL = 5038,
            UNSUPPORTED_TAG = 5039,
            INVAL_TAG = 5040,
            IMPORT_PARAM_MISMATCH = 5041,
            SEC_HW_ACCESS_DENIED = 5042,
            CONCUR_ACCESS_CONFLICT = 5043,
            SEC_HW_BUSY = 5044,
            SEC_HW_COM_FAIL = 5045,
            UNSUPPORTED_EC_FIELD = 5046,
            MISSING_NONCE = 5047,
            INVAL_NONCE = 5048,
            MISSING_MAC_LEN = 5049,
            KEY_RATE_LIMIT_EXCEEDED = 5050,
            CALLER_NONCE_PROHIBITED = 5051,
            KEY_MAX_OPS_EXCEEDED = 5052,
            INVAL_MAC_LEN = 5053,
            MISSING_MIN_MAC_LEN = 5054,
            UNSUPPORTED_MIN_MAC_LEN = 5055,
            UNSUPPORTED_KDF = 5056,
            UNSUPPORTED_EC_CURVE = 5057,
            KEY_REQ_UPGRADE = 5058,
            ATTESTATION_CHLNG_MIS = 5059,
            KM_NOT_CONFGRD = 5060,
            ATTESTATION_APPID_MIS = 5061,
            CANNOT_ATTEST_IDS = 5062,
            UNIMPLEMENTED = 5063,
            VER_MISMATCH = 5064,
            SOTER_ERR = 5065,
            DMA_ERR = 5066,
            DIV_ERR = 5067,
            OVERFLOW_UNDERFLOW = 5068,
            RNG_UNSEEDED = 5069,
            MEM_ERR = 5070,
            MODULUS_ERR = 5071,
            DECODING_ERR = 5072,
            INVALID_LENGTH = 5073
        };
    
        ErrorCode()
            : CommonAPI::Enumeration< int32_t>(static_cast< int32_t>(Literal::SUCCESS)) {}
        ErrorCode(Literal _literal)
            : CommonAPI::Enumeration< int32_t>(static_cast< int32_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< int32_t>(Literal::SUCCESS):
                case static_cast< int32_t>(Literal::RADIO_NOT_AVAILABLE):
                case static_cast< int32_t>(Literal::GENERIC_FAILURE):
                case static_cast< int32_t>(Literal::PASSWORD_INCORRECT):
                case static_cast< int32_t>(Literal::SIM_PIN2):
                case static_cast< int32_t>(Literal::SIM_PUK2):
                case static_cast< int32_t>(Literal::REQUEST_NOT_SUPPORTED):
                case static_cast< int32_t>(Literal::CANCELLED):
                case static_cast< int32_t>(Literal::OP_NOT_ALLOWED_DURING_VOICE_CALL):
                case static_cast< int32_t>(Literal::OP_NOT_ALLOWED_BEFORE_REG_TO_NW):
                case static_cast< int32_t>(Literal::SMS_SEND_FAIL_RETRY):
                case static_cast< int32_t>(Literal::SIM_ABSENT):
                case static_cast< int32_t>(Literal::SUBSCRIPTION_NOT_AVAILABLE):
                case static_cast< int32_t>(Literal::MODE_NOT_SUPPORTED):
                case static_cast< int32_t>(Literal::FDN_CHECK_FAILURE):
                case static_cast< int32_t>(Literal::ILLEGAL_SIM_OR_ME):
                case static_cast< int32_t>(Literal::MISSING_RESOURCE):
                case static_cast< int32_t>(Literal::NO_SUCH_ELEMENT):
                case static_cast< int32_t>(Literal::DIAL_MODIFIED_TO_USSD):
                case static_cast< int32_t>(Literal::DIAL_MODIFIED_TO_SS):
                case static_cast< int32_t>(Literal::DIAL_MODIFIED_TO_DIAL):
                case static_cast< int32_t>(Literal::USSD_MODIFIED_TO_DIAL):
                case static_cast< int32_t>(Literal::USSD_MODIFIED_TO_SS):
                case static_cast< int32_t>(Literal::USSD_MODIFIED_TO_USSD):
                case static_cast< int32_t>(Literal::SS_MODIFIED_TO_DIAL):
                case static_cast< int32_t>(Literal::SS_MODIFIED_TO_USSD):
                case static_cast< int32_t>(Literal::SUBSCRIPTION_NOT_SUPPORTED):
                case static_cast< int32_t>(Literal::SS_MODIFIED_TO_SS):
                case static_cast< int32_t>(Literal::LCE_NOT_SUPPORTED):
                case static_cast< int32_t>(Literal::NO_MEMORY):
                case static_cast< int32_t>(Literal::INTERNAL_ERR):
                case static_cast< int32_t>(Literal::SYSTEM_ERR):
                case static_cast< int32_t>(Literal::MODEM_ERR):
                case static_cast< int32_t>(Literal::INVALID_STATE):
                case static_cast< int32_t>(Literal::NO_RESOURCES):
                case static_cast< int32_t>(Literal::SIM_ERR):
                case static_cast< int32_t>(Literal::INVALID_ARGUMENTS):
                case static_cast< int32_t>(Literal::INVALID_SIM_STATE):
                case static_cast< int32_t>(Literal::INVALID_MODEM_STATE):
                case static_cast< int32_t>(Literal::INVALID_CALL_ID):
                case static_cast< int32_t>(Literal::NO_SMS_TO_ACK):
                case static_cast< int32_t>(Literal::NETWORK_ERR):
                case static_cast< int32_t>(Literal::REQUEST_RATE_LIMITED):
                case static_cast< int32_t>(Literal::SIM_BUSY):
                case static_cast< int32_t>(Literal::SIM_FULL):
                case static_cast< int32_t>(Literal::NETWORK_REJECT):
                case static_cast< int32_t>(Literal::OPERATION_NOT_ALLOWED):
                case static_cast< int32_t>(Literal::EMPTY_RECORD):
                case static_cast< int32_t>(Literal::INVALID_SMS_FORMAT):
                case static_cast< int32_t>(Literal::ENCODING_ERR):
                case static_cast< int32_t>(Literal::INVALID_SMSC_ADDRESS):
                case static_cast< int32_t>(Literal::NO_SUCH_ENTRY):
                case static_cast< int32_t>(Literal::NETWORK_NOT_READY):
                case static_cast< int32_t>(Literal::NOT_PROVISIONED):
                case static_cast< int32_t>(Literal::NO_SUBSCRIPTION):
                case static_cast< int32_t>(Literal::NO_NETWORK_FOUND):
                case static_cast< int32_t>(Literal::DEVICE_IN_USE):
                case static_cast< int32_t>(Literal::ABORTED):
                case static_cast< int32_t>(Literal::INCOMPATIBLE_STATE):
                case static_cast< int32_t>(Literal::NO_EFFECT):
                case static_cast< int32_t>(Literal::DEVICE_NOT_READY):
                case static_cast< int32_t>(Literal::MISSING_ARGUMENTS):
                case static_cast< int32_t>(Literal::PIN_PERM_BLOCKED):
                case static_cast< int32_t>(Literal::PIN_BLOCKED):
                case static_cast< int32_t>(Literal::MALFORMED_MSG):
                case static_cast< int32_t>(Literal::INTERNAL):
                case static_cast< int32_t>(Literal::CLIENT_IDS_EXHAUSTED):
                case static_cast< int32_t>(Literal::UNABORTABLE_TRANSACTION):
                case static_cast< int32_t>(Literal::INVALID_CLIENT_ID):
                case static_cast< int32_t>(Literal::NO_THRESHOLDS):
                case static_cast< int32_t>(Literal::INVALID_HANDLE):
                case static_cast< int32_t>(Literal::INVALID_PROFILE):
                case static_cast< int32_t>(Literal::INVALID_PINID):
                case static_cast< int32_t>(Literal::INCORRECT_PIN):
                case static_cast< int32_t>(Literal::CALL_FAILED):
                case static_cast< int32_t>(Literal::OUT_OF_CALL):
                case static_cast< int32_t>(Literal::MISSING_ARG):
                case static_cast< int32_t>(Literal::ARG_TOO_LONG):
                case static_cast< int32_t>(Literal::INVALID_TX_ID):
                case static_cast< int32_t>(Literal::OP_NETWORK_UNSUPPORTED):
                case static_cast< int32_t>(Literal::OP_DEVICE_UNSUPPORTED):
                case static_cast< int32_t>(Literal::NO_FREE_PROFILE):
                case static_cast< int32_t>(Literal::INVALID_PDP_TYPE):
                case static_cast< int32_t>(Literal::INVALID_TECH_PREF):
                case static_cast< int32_t>(Literal::INVALID_PROFILE_TYPE):
                case static_cast< int32_t>(Literal::INVALID_SERVICE_TYPE):
                case static_cast< int32_t>(Literal::INVALID_REGISTER_ACTION):
                case static_cast< int32_t>(Literal::INVALID_PS_ATTACH_ACTION):
                case static_cast< int32_t>(Literal::AUTHENTICATION_FAILED):
                case static_cast< int32_t>(Literal::SIM_NOT_INITIALIZED):
                case static_cast< int32_t>(Literal::MAX_QOS_REQUESTS_IN_USE):
                case static_cast< int32_t>(Literal::INCORRECT_FLOW_FILTER):
                case static_cast< int32_t>(Literal::NETWORK_QOS_UNAWARE):
                case static_cast< int32_t>(Literal::INVALID_ID):
                case static_cast< int32_t>(Literal::REQUESTED_NUM_UNSUPPORTED):
                case static_cast< int32_t>(Literal::INTERFACE_NOT_FOUND):
                case static_cast< int32_t>(Literal::FLOW_SUSPENDED):
                case static_cast< int32_t>(Literal::INVALID_DATA_FORMAT):
                case static_cast< int32_t>(Literal::GENERAL):
                case static_cast< int32_t>(Literal::UNKNOWN):
                case static_cast< int32_t>(Literal::INVALID_ARG):
                case static_cast< int32_t>(Literal::INVALID_INDEX):
                case static_cast< int32_t>(Literal::NO_ENTRY):
                case static_cast< int32_t>(Literal::DEVICE_STORAGE_FULL):
                case static_cast< int32_t>(Literal::CAUSE_CODE):
                case static_cast< int32_t>(Literal::MESSAGE_NOT_SENT):
                case static_cast< int32_t>(Literal::MESSAGE_DELIVERY_FAILURE):
                case static_cast< int32_t>(Literal::INVALID_MESSAGE_ID):
                case static_cast< int32_t>(Literal::ENCODING):
                case static_cast< int32_t>(Literal::AUTHENTICATION_LOCK):
                case static_cast< int32_t>(Literal::INVALID_TRANSITION):
                case static_cast< int32_t>(Literal::NOT_A_MCAST_IFACE):
                case static_cast< int32_t>(Literal::MAX_MCAST_REQUESTS_IN_USE):
                case static_cast< int32_t>(Literal::INVALID_MCAST_HANDLE):
                case static_cast< int32_t>(Literal::INVALID_IP_FAMILY_PREF):
                case static_cast< int32_t>(Literal::SESSION_INACTIVE):
                case static_cast< int32_t>(Literal::SESSION_INVALID):
                case static_cast< int32_t>(Literal::SESSION_OWNERSHIP):
                case static_cast< int32_t>(Literal::INSUFFICIENT_RESOURCES):
                case static_cast< int32_t>(Literal::DISABLED):
                case static_cast< int32_t>(Literal::INVALID_OPERATION):
                case static_cast< int32_t>(Literal::INVALID_QMI_CMD):
                case static_cast< int32_t>(Literal::TPDU_TYPE):
                case static_cast< int32_t>(Literal::SMSC_ADDR):
                case static_cast< int32_t>(Literal::INFO_UNAVAILABLE):
                case static_cast< int32_t>(Literal::SEGMENT_TOO_LONG):
                case static_cast< int32_t>(Literal::SEGMENT_ORDER):
                case static_cast< int32_t>(Literal::BUNDLING_NOT_SUPPORTED):
                case static_cast< int32_t>(Literal::OP_PARTIAL_FAILURE):
                case static_cast< int32_t>(Literal::POLICY_MISMATCH):
                case static_cast< int32_t>(Literal::SIM_FILE_NOT_FOUND):
                case static_cast< int32_t>(Literal::EXTENDED_INTERNAL):
                case static_cast< int32_t>(Literal::ACCESS_DENIED):
                case static_cast< int32_t>(Literal::HARDWARE_RESTRICTED):
                case static_cast< int32_t>(Literal::ACK_NOT_SENT):
                case static_cast< int32_t>(Literal::INJECT_TIMEOUT):
                case static_cast< int32_t>(Literal::FDN_RESTRICT):
                case static_cast< int32_t>(Literal::SUPS_FAILURE_CAUSE):
                case static_cast< int32_t>(Literal::NO_RADIO):
                case static_cast< int32_t>(Literal::NOT_SUPPORTED):
                case static_cast< int32_t>(Literal::CARD_CALL_CONTROL_FAILED):
                case static_cast< int32_t>(Literal::NETWORK_ABORTED):
                case static_cast< int32_t>(Literal::MSG_BLOCKED):
                case static_cast< int32_t>(Literal::INVALID_SESSION_TYPE):
                case static_cast< int32_t>(Literal::INVALID_PB_TYPE):
                case static_cast< int32_t>(Literal::NO_SIM):
                case static_cast< int32_t>(Literal::PB_NOT_READY):
                case static_cast< int32_t>(Literal::PIN_RESTRICTION):
                case static_cast< int32_t>(Literal::PIN2_RESTRICTION):
                case static_cast< int32_t>(Literal::PUK_RESTRICTION):
                case static_cast< int32_t>(Literal::PUK2_RESTRICTION):
                case static_cast< int32_t>(Literal::PB_ACCESS_RESTRICTED):
                case static_cast< int32_t>(Literal::PB_DELETE_IN_PROG):
                case static_cast< int32_t>(Literal::PB_TEXT_TOO_LONG):
                case static_cast< int32_t>(Literal::PB_NUMBER_TOO_LONG):
                case static_cast< int32_t>(Literal::PB_HIDDEN_KEY_RESTRICTION):
                case static_cast< int32_t>(Literal::PB_NOT_AVAILABLE):
                case static_cast< int32_t>(Literal::DEVICE_MEMORY_ERROR):
                case static_cast< int32_t>(Literal::NO_PERMISSION):
                case static_cast< int32_t>(Literal::TOO_SOON):
                case static_cast< int32_t>(Literal::TIME_NOT_ACQUIRED):
                case static_cast< int32_t>(Literal::OP_IN_PROGRESS):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_FAIL):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_HNDL):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_OP):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_PROFILE_TYPE):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_PROFILE_NUM):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_IDENT):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_LIB_NOT_INITED):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_LEN_INVALID):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_LIST_END):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_SUBS_ID):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_INVAL_PROFILE_FAMILY):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_PROFILE_VERSION_MISMATCH):
                case static_cast< int32_t>(Literal::REG_RESULT_ERR_OUT_OF_MEMORY):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_FILE_ACCESS):
                case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_EOF):
                case static_cast< int32_t>(Literal::REG_RESULT_ERR_VALID_FLAG_NOT_SET):
                case static_cast< int32_t>(Literal::REG_RESULT_ERR_OUT_OF_PROFILES):
                case static_cast< int32_t>(Literal::REG_RESULT_NO_EMERGENCY_PDN_SUPPORT):
                case static_cast< int32_t>(Literal::V2X_ERR_EXCEED_MAX):
                case static_cast< int32_t>(Literal::V2X_ERR_V2X_DISABLED):
                case static_cast< int32_t>(Literal::V2X_ERR_UNKNOWN_SERVICE_ID):
                case static_cast< int32_t>(Literal::V2X_ERR_SRV_ID_L2_ADDRS_NOT_COMPATIBLE):
                case static_cast< int32_t>(Literal::V2X_ERR_PORT_UNAVAIL):
                case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_INVAL_PROFILE_FAMILY):
                case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_ACCESS_ERR):
                case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_CONTEXT_NOT_DEFINED):
                case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_VALID_FLAG_NOT_SET):
                case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_READ_ONLY_FLAG_SET):
                case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_ERR_OUT_OF_PROFILES):
                case static_cast< int32_t>(Literal::DS_PROFILE_3GPP2_ERR_INVALID_IDENT_FOR_PROFILE):
                case static_cast< int32_t>(Literal::DS_PROFILE_3GPP2_ERR_OUT_OF_PROFILE):
                case static_cast< int32_t>(Literal::INTERNAL_ERROR):
                case static_cast< int32_t>(Literal::SERVICE_ERROR):
                case static_cast< int32_t>(Literal::TIMEOUT_ERROR):
                case static_cast< int32_t>(Literal::EXTENDED_ERROR):
                case static_cast< int32_t>(Literal::PORT_NOT_OPEN_ERROR):
                case static_cast< int32_t>(Literal::MEMCOPY_ERROR):
                case static_cast< int32_t>(Literal::INVALID_TRANSACTION):
                case static_cast< int32_t>(Literal::ALLOCATION_FAILURE):
                case static_cast< int32_t>(Literal::TRANSPORT_ERROR):
                case static_cast< int32_t>(Literal::PARAM_ERROR):
                case static_cast< int32_t>(Literal::INVALID_CLIENT):
                case static_cast< int32_t>(Literal::FRAMEWORK_NOT_READY):
                case static_cast< int32_t>(Literal::INVALID_SIGNAL):
                case static_cast< int32_t>(Literal::TRANSPORT_BUSY_ERROR):
                case static_cast< int32_t>(Literal::SUBSYSTEM_UNAVAILABLE):
                case static_cast< int32_t>(Literal::OPERATION_TIMEOUT):
                case static_cast< int32_t>(Literal::ROLLBACK_FAILED):
                case static_cast< int32_t>(Literal::ROT_ALREADY_SET):
                case static_cast< int32_t>(Literal::UNSUPPORTED_PURPOSE):
                case static_cast< int32_t>(Literal::INCOMPATIBLE_PURPOSE):
                case static_cast< int32_t>(Literal::UNSUPPORTED_ALGO):
                case static_cast< int32_t>(Literal::INCOMPATIBLE_ALGO):
                case static_cast< int32_t>(Literal::UNSUPPORTED_KEY_SIZE):
                case static_cast< int32_t>(Literal::UNSUPPORTED_BLOCK_MODE):
                case static_cast< int32_t>(Literal::INCOMPATIBLE_BLOCK_MODE):
                case static_cast< int32_t>(Literal::UNSUPPORTED_MAC_LEN):
                case static_cast< int32_t>(Literal::UNSUPPORTED_PADDING_MODE):
                case static_cast< int32_t>(Literal::UNSUPPORTED_DIGEST):
                case static_cast< int32_t>(Literal::INCOMPATIBLE_DIGEST):
                case static_cast< int32_t>(Literal::INVAL_EXP_TIME):
                case static_cast< int32_t>(Literal::INVAL_USR_ID):
                case static_cast< int32_t>(Literal::INVAL_AUTH_TIMEOUT):
                case static_cast< int32_t>(Literal::UNSUPPORTED_KEY_FMT):
                case static_cast< int32_t>(Literal::INCOMPATIBLE_KEY_FMT):
                case static_cast< int32_t>(Literal::UNSUPPORTED_KEY_ENC_ALGO):
                case static_cast< int32_t>(Literal::UNSUPPORTED_KEY_VRFY_ALGO):
                case static_cast< int32_t>(Literal::INVAL_IN_LEN):
                case static_cast< int32_t>(Literal::INVAL_KEY_EXPRT_OPTNS):
                case static_cast< int32_t>(Literal::DELEGATION_NOT_ALLOWED):
                case static_cast< int32_t>(Literal::KEY_NOT_YET_VALID):
                case static_cast< int32_t>(Literal::KEY_EXPIRED):
                case static_cast< int32_t>(Literal::KEY_USR_NOT_AUTHENTICATED):
                case static_cast< int32_t>(Literal::OUT_PARAMETER_NULL):
                case static_cast< int32_t>(Literal::INVAL_OPERATION_HNDL):
                case static_cast< int32_t>(Literal::INSUFFICIENT_BUF_SPACE):
                case static_cast< int32_t>(Literal::VERIFICATION_FAILED):
                case static_cast< int32_t>(Literal::TOO_MANY_OPS):
                case static_cast< int32_t>(Literal::UNEXPECTED_NULL_PTR):
                case static_cast< int32_t>(Literal::INVAL_KEY_BLOB):
                case static_cast< int32_t>(Literal::IMPORTED_KEY_NOT_ENC):
                case static_cast< int32_t>(Literal::IMPORTED_KEY_DEC_FAIL):
                case static_cast< int32_t>(Literal::IMPORTED_KEY_NOT_SIGNED):
                case static_cast< int32_t>(Literal::IMPORTED_KEY_VRFY_FAIL):
                case static_cast< int32_t>(Literal::UNSUPPORTED_TAG):
                case static_cast< int32_t>(Literal::INVAL_TAG):
                case static_cast< int32_t>(Literal::IMPORT_PARAM_MISMATCH):
                case static_cast< int32_t>(Literal::SEC_HW_ACCESS_DENIED):
                case static_cast< int32_t>(Literal::CONCUR_ACCESS_CONFLICT):
                case static_cast< int32_t>(Literal::SEC_HW_BUSY):
                case static_cast< int32_t>(Literal::SEC_HW_COM_FAIL):
                case static_cast< int32_t>(Literal::UNSUPPORTED_EC_FIELD):
                case static_cast< int32_t>(Literal::MISSING_NONCE):
                case static_cast< int32_t>(Literal::INVAL_NONCE):
                case static_cast< int32_t>(Literal::MISSING_MAC_LEN):
                case static_cast< int32_t>(Literal::KEY_RATE_LIMIT_EXCEEDED):
                case static_cast< int32_t>(Literal::CALLER_NONCE_PROHIBITED):
                case static_cast< int32_t>(Literal::KEY_MAX_OPS_EXCEEDED):
                case static_cast< int32_t>(Literal::INVAL_MAC_LEN):
                case static_cast< int32_t>(Literal::MISSING_MIN_MAC_LEN):
                case static_cast< int32_t>(Literal::UNSUPPORTED_MIN_MAC_LEN):
                case static_cast< int32_t>(Literal::UNSUPPORTED_KDF):
                case static_cast< int32_t>(Literal::UNSUPPORTED_EC_CURVE):
                case static_cast< int32_t>(Literal::KEY_REQ_UPGRADE):
                case static_cast< int32_t>(Literal::ATTESTATION_CHLNG_MIS):
                case static_cast< int32_t>(Literal::KM_NOT_CONFGRD):
                case static_cast< int32_t>(Literal::ATTESTATION_APPID_MIS):
                case static_cast< int32_t>(Literal::CANNOT_ATTEST_IDS):
                case static_cast< int32_t>(Literal::UNIMPLEMENTED):
                case static_cast< int32_t>(Literal::VER_MISMATCH):
                case static_cast< int32_t>(Literal::SOTER_ERR):
                case static_cast< int32_t>(Literal::DMA_ERR):
                case static_cast< int32_t>(Literal::DIV_ERR):
                case static_cast< int32_t>(Literal::OVERFLOW_UNDERFLOW):
                case static_cast< int32_t>(Literal::RNG_UNSEEDED):
                case static_cast< int32_t>(Literal::MEM_ERR):
                case static_cast< int32_t>(Literal::MODULUS_ERR):
                case static_cast< int32_t>(Literal::DECODING_ERR):
                case static_cast< int32_t>(Literal::INVALID_LENGTH):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const ErrorCode &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const ErrorCode &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const ErrorCode &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const ErrorCode &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const ErrorCode &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const ErrorCode &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< int32_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< int32_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< int32_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< int32_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< int32_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< int32_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< int32_t>(Literal::SUCCESS): return "SUCCESS";
            case static_cast< int32_t>(Literal::RADIO_NOT_AVAILABLE): return "RADIO_NOT_AVAILABLE";
            case static_cast< int32_t>(Literal::GENERIC_FAILURE): return "GENERIC_FAILURE";
            case static_cast< int32_t>(Literal::PASSWORD_INCORRECT): return "PASSWORD_INCORRECT";
            case static_cast< int32_t>(Literal::SIM_PIN2): return "SIM_PIN2";
            case static_cast< int32_t>(Literal::SIM_PUK2): return "SIM_PUK2";
            case static_cast< int32_t>(Literal::REQUEST_NOT_SUPPORTED): return "REQUEST_NOT_SUPPORTED";
            case static_cast< int32_t>(Literal::CANCELLED): return "CANCELLED";
            case static_cast< int32_t>(Literal::OP_NOT_ALLOWED_DURING_VOICE_CALL): return "OP_NOT_ALLOWED_DURING_VOICE_CALL";
            case static_cast< int32_t>(Literal::OP_NOT_ALLOWED_BEFORE_REG_TO_NW): return "OP_NOT_ALLOWED_BEFORE_REG_TO_NW";
            case static_cast< int32_t>(Literal::SMS_SEND_FAIL_RETRY): return "SMS_SEND_FAIL_RETRY";
            case static_cast< int32_t>(Literal::SIM_ABSENT): return "SIM_ABSENT";
            case static_cast< int32_t>(Literal::SUBSCRIPTION_NOT_AVAILABLE): return "SUBSCRIPTION_NOT_AVAILABLE";
            case static_cast< int32_t>(Literal::MODE_NOT_SUPPORTED): return "MODE_NOT_SUPPORTED";
            case static_cast< int32_t>(Literal::FDN_CHECK_FAILURE): return "FDN_CHECK_FAILURE";
            case static_cast< int32_t>(Literal::ILLEGAL_SIM_OR_ME): return "ILLEGAL_SIM_OR_ME";
            case static_cast< int32_t>(Literal::MISSING_RESOURCE): return "MISSING_RESOURCE";
            case static_cast< int32_t>(Literal::NO_SUCH_ELEMENT): return "NO_SUCH_ELEMENT";
            case static_cast< int32_t>(Literal::DIAL_MODIFIED_TO_USSD): return "DIAL_MODIFIED_TO_USSD";
            case static_cast< int32_t>(Literal::DIAL_MODIFIED_TO_SS): return "DIAL_MODIFIED_TO_SS";
            case static_cast< int32_t>(Literal::DIAL_MODIFIED_TO_DIAL): return "DIAL_MODIFIED_TO_DIAL";
            case static_cast< int32_t>(Literal::USSD_MODIFIED_TO_DIAL): return "USSD_MODIFIED_TO_DIAL";
            case static_cast< int32_t>(Literal::USSD_MODIFIED_TO_SS): return "USSD_MODIFIED_TO_SS";
            case static_cast< int32_t>(Literal::USSD_MODIFIED_TO_USSD): return "USSD_MODIFIED_TO_USSD";
            case static_cast< int32_t>(Literal::SS_MODIFIED_TO_DIAL): return "SS_MODIFIED_TO_DIAL";
            case static_cast< int32_t>(Literal::SS_MODIFIED_TO_USSD): return "SS_MODIFIED_TO_USSD";
            case static_cast< int32_t>(Literal::SUBSCRIPTION_NOT_SUPPORTED): return "SUBSCRIPTION_NOT_SUPPORTED";
            case static_cast< int32_t>(Literal::SS_MODIFIED_TO_SS): return "SS_MODIFIED_TO_SS";
            case static_cast< int32_t>(Literal::LCE_NOT_SUPPORTED): return "LCE_NOT_SUPPORTED";
            case static_cast< int32_t>(Literal::NO_MEMORY): return "NO_MEMORY";
            case static_cast< int32_t>(Literal::INTERNAL_ERR): return "INTERNAL_ERR";
            case static_cast< int32_t>(Literal::SYSTEM_ERR): return "SYSTEM_ERR";
            case static_cast< int32_t>(Literal::MODEM_ERR): return "MODEM_ERR";
            case static_cast< int32_t>(Literal::INVALID_STATE): return "INVALID_STATE";
            case static_cast< int32_t>(Literal::NO_RESOURCES): return "NO_RESOURCES";
            case static_cast< int32_t>(Literal::SIM_ERR): return "SIM_ERR";
            case static_cast< int32_t>(Literal::INVALID_ARGUMENTS): return "INVALID_ARGUMENTS";
            case static_cast< int32_t>(Literal::INVALID_SIM_STATE): return "INVALID_SIM_STATE";
            case static_cast< int32_t>(Literal::INVALID_MODEM_STATE): return "INVALID_MODEM_STATE";
            case static_cast< int32_t>(Literal::INVALID_CALL_ID): return "INVALID_CALL_ID";
            case static_cast< int32_t>(Literal::NO_SMS_TO_ACK): return "NO_SMS_TO_ACK";
            case static_cast< int32_t>(Literal::NETWORK_ERR): return "NETWORK_ERR";
            case static_cast< int32_t>(Literal::REQUEST_RATE_LIMITED): return "REQUEST_RATE_LIMITED";
            case static_cast< int32_t>(Literal::SIM_BUSY): return "SIM_BUSY";
            case static_cast< int32_t>(Literal::SIM_FULL): return "SIM_FULL";
            case static_cast< int32_t>(Literal::NETWORK_REJECT): return "NETWORK_REJECT";
            case static_cast< int32_t>(Literal::OPERATION_NOT_ALLOWED): return "OPERATION_NOT_ALLOWED";
            case static_cast< int32_t>(Literal::EMPTY_RECORD): return "EMPTY_RECORD";
            case static_cast< int32_t>(Literal::INVALID_SMS_FORMAT): return "INVALID_SMS_FORMAT";
            case static_cast< int32_t>(Literal::ENCODING_ERR): return "ENCODING_ERR";
            case static_cast< int32_t>(Literal::INVALID_SMSC_ADDRESS): return "INVALID_SMSC_ADDRESS";
            case static_cast< int32_t>(Literal::NO_SUCH_ENTRY): return "NO_SUCH_ENTRY";
            case static_cast< int32_t>(Literal::NETWORK_NOT_READY): return "NETWORK_NOT_READY";
            case static_cast< int32_t>(Literal::NOT_PROVISIONED): return "NOT_PROVISIONED";
            case static_cast< int32_t>(Literal::NO_SUBSCRIPTION): return "NO_SUBSCRIPTION";
            case static_cast< int32_t>(Literal::NO_NETWORK_FOUND): return "NO_NETWORK_FOUND";
            case static_cast< int32_t>(Literal::DEVICE_IN_USE): return "DEVICE_IN_USE";
            case static_cast< int32_t>(Literal::ABORTED): return "ABORTED";
            case static_cast< int32_t>(Literal::INCOMPATIBLE_STATE): return "INCOMPATIBLE_STATE";
            case static_cast< int32_t>(Literal::NO_EFFECT): return "NO_EFFECT";
            case static_cast< int32_t>(Literal::DEVICE_NOT_READY): return "DEVICE_NOT_READY";
            case static_cast< int32_t>(Literal::MISSING_ARGUMENTS): return "MISSING_ARGUMENTS";
            case static_cast< int32_t>(Literal::PIN_PERM_BLOCKED): return "PIN_PERM_BLOCKED";
            case static_cast< int32_t>(Literal::PIN_BLOCKED): return "PIN_BLOCKED";
            case static_cast< int32_t>(Literal::MALFORMED_MSG): return "MALFORMED_MSG";
            case static_cast< int32_t>(Literal::INTERNAL): return "INTERNAL";
            case static_cast< int32_t>(Literal::CLIENT_IDS_EXHAUSTED): return "CLIENT_IDS_EXHAUSTED";
            case static_cast< int32_t>(Literal::UNABORTABLE_TRANSACTION): return "UNABORTABLE_TRANSACTION";
            case static_cast< int32_t>(Literal::INVALID_CLIENT_ID): return "INVALID_CLIENT_ID";
            case static_cast< int32_t>(Literal::NO_THRESHOLDS): return "NO_THRESHOLDS";
            case static_cast< int32_t>(Literal::INVALID_HANDLE): return "INVALID_HANDLE";
            case static_cast< int32_t>(Literal::INVALID_PROFILE): return "INVALID_PROFILE";
            case static_cast< int32_t>(Literal::INVALID_PINID): return "INVALID_PINID";
            case static_cast< int32_t>(Literal::INCORRECT_PIN): return "INCORRECT_PIN";
            case static_cast< int32_t>(Literal::CALL_FAILED): return "CALL_FAILED";
            case static_cast< int32_t>(Literal::OUT_OF_CALL): return "OUT_OF_CALL";
            case static_cast< int32_t>(Literal::MISSING_ARG): return "MISSING_ARG";
            case static_cast< int32_t>(Literal::ARG_TOO_LONG): return "ARG_TOO_LONG";
            case static_cast< int32_t>(Literal::INVALID_TX_ID): return "INVALID_TX_ID";
            case static_cast< int32_t>(Literal::OP_NETWORK_UNSUPPORTED): return "OP_NETWORK_UNSUPPORTED";
            case static_cast< int32_t>(Literal::OP_DEVICE_UNSUPPORTED): return "OP_DEVICE_UNSUPPORTED";
            case static_cast< int32_t>(Literal::NO_FREE_PROFILE): return "NO_FREE_PROFILE";
            case static_cast< int32_t>(Literal::INVALID_PDP_TYPE): return "INVALID_PDP_TYPE";
            case static_cast< int32_t>(Literal::INVALID_TECH_PREF): return "INVALID_TECH_PREF";
            case static_cast< int32_t>(Literal::INVALID_PROFILE_TYPE): return "INVALID_PROFILE_TYPE";
            case static_cast< int32_t>(Literal::INVALID_SERVICE_TYPE): return "INVALID_SERVICE_TYPE";
            case static_cast< int32_t>(Literal::INVALID_REGISTER_ACTION): return "INVALID_REGISTER_ACTION";
            case static_cast< int32_t>(Literal::INVALID_PS_ATTACH_ACTION): return "INVALID_PS_ATTACH_ACTION";
            case static_cast< int32_t>(Literal::AUTHENTICATION_FAILED): return "AUTHENTICATION_FAILED";
            case static_cast< int32_t>(Literal::SIM_NOT_INITIALIZED): return "SIM_NOT_INITIALIZED";
            case static_cast< int32_t>(Literal::MAX_QOS_REQUESTS_IN_USE): return "MAX_QOS_REQUESTS_IN_USE";
            case static_cast< int32_t>(Literal::INCORRECT_FLOW_FILTER): return "INCORRECT_FLOW_FILTER";
            case static_cast< int32_t>(Literal::NETWORK_QOS_UNAWARE): return "NETWORK_QOS_UNAWARE";
            case static_cast< int32_t>(Literal::INVALID_ID): return "INVALID_ID";
            case static_cast< int32_t>(Literal::REQUESTED_NUM_UNSUPPORTED): return "REQUESTED_NUM_UNSUPPORTED";
            case static_cast< int32_t>(Literal::INTERFACE_NOT_FOUND): return "INTERFACE_NOT_FOUND";
            case static_cast< int32_t>(Literal::FLOW_SUSPENDED): return "FLOW_SUSPENDED";
            case static_cast< int32_t>(Literal::INVALID_DATA_FORMAT): return "INVALID_DATA_FORMAT";
            case static_cast< int32_t>(Literal::GENERAL): return "GENERAL";
            case static_cast< int32_t>(Literal::UNKNOWN): return "UNKNOWN";
            case static_cast< int32_t>(Literal::INVALID_ARG): return "INVALID_ARG";
            case static_cast< int32_t>(Literal::INVALID_INDEX): return "INVALID_INDEX";
            case static_cast< int32_t>(Literal::NO_ENTRY): return "NO_ENTRY";
            case static_cast< int32_t>(Literal::DEVICE_STORAGE_FULL): return "DEVICE_STORAGE_FULL";
            case static_cast< int32_t>(Literal::CAUSE_CODE): return "CAUSE_CODE";
            case static_cast< int32_t>(Literal::MESSAGE_NOT_SENT): return "MESSAGE_NOT_SENT";
            case static_cast< int32_t>(Literal::MESSAGE_DELIVERY_FAILURE): return "MESSAGE_DELIVERY_FAILURE";
            case static_cast< int32_t>(Literal::INVALID_MESSAGE_ID): return "INVALID_MESSAGE_ID";
            case static_cast< int32_t>(Literal::ENCODING): return "ENCODING";
            case static_cast< int32_t>(Literal::AUTHENTICATION_LOCK): return "AUTHENTICATION_LOCK";
            case static_cast< int32_t>(Literal::INVALID_TRANSITION): return "INVALID_TRANSITION";
            case static_cast< int32_t>(Literal::NOT_A_MCAST_IFACE): return "NOT_A_MCAST_IFACE";
            case static_cast< int32_t>(Literal::MAX_MCAST_REQUESTS_IN_USE): return "MAX_MCAST_REQUESTS_IN_USE";
            case static_cast< int32_t>(Literal::INVALID_MCAST_HANDLE): return "INVALID_MCAST_HANDLE";
            case static_cast< int32_t>(Literal::INVALID_IP_FAMILY_PREF): return "INVALID_IP_FAMILY_PREF";
            case static_cast< int32_t>(Literal::SESSION_INACTIVE): return "SESSION_INACTIVE";
            case static_cast< int32_t>(Literal::SESSION_INVALID): return "SESSION_INVALID";
            case static_cast< int32_t>(Literal::SESSION_OWNERSHIP): return "SESSION_OWNERSHIP";
            case static_cast< int32_t>(Literal::INSUFFICIENT_RESOURCES): return "INSUFFICIENT_RESOURCES";
            case static_cast< int32_t>(Literal::DISABLED): return "DISABLED";
            case static_cast< int32_t>(Literal::INVALID_OPERATION): return "INVALID_OPERATION";
            case static_cast< int32_t>(Literal::INVALID_QMI_CMD): return "INVALID_QMI_CMD";
            case static_cast< int32_t>(Literal::TPDU_TYPE): return "TPDU_TYPE";
            case static_cast< int32_t>(Literal::SMSC_ADDR): return "SMSC_ADDR";
            case static_cast< int32_t>(Literal::INFO_UNAVAILABLE): return "INFO_UNAVAILABLE";
            case static_cast< int32_t>(Literal::SEGMENT_TOO_LONG): return "SEGMENT_TOO_LONG";
            case static_cast< int32_t>(Literal::SEGMENT_ORDER): return "SEGMENT_ORDER";
            case static_cast< int32_t>(Literal::BUNDLING_NOT_SUPPORTED): return "BUNDLING_NOT_SUPPORTED";
            case static_cast< int32_t>(Literal::OP_PARTIAL_FAILURE): return "OP_PARTIAL_FAILURE";
            case static_cast< int32_t>(Literal::POLICY_MISMATCH): return "POLICY_MISMATCH";
            case static_cast< int32_t>(Literal::SIM_FILE_NOT_FOUND): return "SIM_FILE_NOT_FOUND";
            case static_cast< int32_t>(Literal::EXTENDED_INTERNAL): return "EXTENDED_INTERNAL";
            case static_cast< int32_t>(Literal::ACCESS_DENIED): return "ACCESS_DENIED";
            case static_cast< int32_t>(Literal::HARDWARE_RESTRICTED): return "HARDWARE_RESTRICTED";
            case static_cast< int32_t>(Literal::ACK_NOT_SENT): return "ACK_NOT_SENT";
            case static_cast< int32_t>(Literal::INJECT_TIMEOUT): return "INJECT_TIMEOUT";
            case static_cast< int32_t>(Literal::FDN_RESTRICT): return "FDN_RESTRICT";
            case static_cast< int32_t>(Literal::SUPS_FAILURE_CAUSE): return "SUPS_FAILURE_CAUSE";
            case static_cast< int32_t>(Literal::NO_RADIO): return "NO_RADIO";
            case static_cast< int32_t>(Literal::NOT_SUPPORTED): return "NOT_SUPPORTED";
            case static_cast< int32_t>(Literal::CARD_CALL_CONTROL_FAILED): return "CARD_CALL_CONTROL_FAILED";
            case static_cast< int32_t>(Literal::NETWORK_ABORTED): return "NETWORK_ABORTED";
            case static_cast< int32_t>(Literal::MSG_BLOCKED): return "MSG_BLOCKED";
            case static_cast< int32_t>(Literal::INVALID_SESSION_TYPE): return "INVALID_SESSION_TYPE";
            case static_cast< int32_t>(Literal::INVALID_PB_TYPE): return "INVALID_PB_TYPE";
            case static_cast< int32_t>(Literal::NO_SIM): return "NO_SIM";
            case static_cast< int32_t>(Literal::PB_NOT_READY): return "PB_NOT_READY";
            case static_cast< int32_t>(Literal::PIN_RESTRICTION): return "PIN_RESTRICTION";
            case static_cast< int32_t>(Literal::PIN2_RESTRICTION): return "PIN2_RESTRICTION";
            case static_cast< int32_t>(Literal::PUK_RESTRICTION): return "PUK_RESTRICTION";
            case static_cast< int32_t>(Literal::PUK2_RESTRICTION): return "PUK2_RESTRICTION";
            case static_cast< int32_t>(Literal::PB_ACCESS_RESTRICTED): return "PB_ACCESS_RESTRICTED";
            case static_cast< int32_t>(Literal::PB_DELETE_IN_PROG): return "PB_DELETE_IN_PROG";
            case static_cast< int32_t>(Literal::PB_TEXT_TOO_LONG): return "PB_TEXT_TOO_LONG";
            case static_cast< int32_t>(Literal::PB_NUMBER_TOO_LONG): return "PB_NUMBER_TOO_LONG";
            case static_cast< int32_t>(Literal::PB_HIDDEN_KEY_RESTRICTION): return "PB_HIDDEN_KEY_RESTRICTION";
            case static_cast< int32_t>(Literal::PB_NOT_AVAILABLE): return "PB_NOT_AVAILABLE";
            case static_cast< int32_t>(Literal::DEVICE_MEMORY_ERROR): return "DEVICE_MEMORY_ERROR";
            case static_cast< int32_t>(Literal::NO_PERMISSION): return "NO_PERMISSION";
            case static_cast< int32_t>(Literal::TOO_SOON): return "TOO_SOON";
            case static_cast< int32_t>(Literal::TIME_NOT_ACQUIRED): return "TIME_NOT_ACQUIRED";
            case static_cast< int32_t>(Literal::OP_IN_PROGRESS): return "OP_IN_PROGRESS";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_FAIL): return "DS_PROFILE_REG_RESULT_FAIL";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_HNDL): return "DS_PROFILE_REG_RESULT_ERR_INVAL_HNDL";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_OP): return "DS_PROFILE_REG_RESULT_ERR_INVAL_OP";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_PROFILE_TYPE): return "DS_PROFILE_REG_RESULT_ERR_INVAL_PROFILE_TYPE";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_PROFILE_NUM): return "DS_PROFILE_REG_RESULT_ERR_INVAL_PROFILE_NUM";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_IDENT): return "DS_PROFILE_REG_RESULT_ERR_INVAL_IDENT";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL): return "DS_PROFILE_REG_RESULT_ERR_INVAL";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_LIB_NOT_INITED): return "DS_PROFILE_REG_RESULT_ERR_LIB_NOT_INITED";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_LEN_INVALID): return "DS_PROFILE_REG_RESULT_ERR_LEN_INVALID";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_LIST_END): return "DS_PROFILE_REG_RESULT_LIST_END";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_INVAL_SUBS_ID): return "DS_PROFILE_REG_RESULT_ERR_INVAL_SUBS_ID";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_INVAL_PROFILE_FAMILY): return "DS_PROFILE_REG_INVAL_PROFILE_FAMILY";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_PROFILE_VERSION_MISMATCH): return "DS_PROFILE_REG_PROFILE_VERSION_MISMATCH";
            case static_cast< int32_t>(Literal::REG_RESULT_ERR_OUT_OF_MEMORY): return "REG_RESULT_ERR_OUT_OF_MEMORY";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_FILE_ACCESS): return "DS_PROFILE_REG_RESULT_ERR_FILE_ACCESS";
            case static_cast< int32_t>(Literal::DS_PROFILE_REG_RESULT_ERR_EOF): return "DS_PROFILE_REG_RESULT_ERR_EOF";
            case static_cast< int32_t>(Literal::REG_RESULT_ERR_VALID_FLAG_NOT_SET): return "REG_RESULT_ERR_VALID_FLAG_NOT_SET";
            case static_cast< int32_t>(Literal::REG_RESULT_ERR_OUT_OF_PROFILES): return "REG_RESULT_ERR_OUT_OF_PROFILES";
            case static_cast< int32_t>(Literal::REG_RESULT_NO_EMERGENCY_PDN_SUPPORT): return "REG_RESULT_NO_EMERGENCY_PDN_SUPPORT";
            case static_cast< int32_t>(Literal::V2X_ERR_EXCEED_MAX): return "V2X_ERR_EXCEED_MAX";
            case static_cast< int32_t>(Literal::V2X_ERR_V2X_DISABLED): return "V2X_ERR_V2X_DISABLED";
            case static_cast< int32_t>(Literal::V2X_ERR_UNKNOWN_SERVICE_ID): return "V2X_ERR_UNKNOWN_SERVICE_ID";
            case static_cast< int32_t>(Literal::V2X_ERR_SRV_ID_L2_ADDRS_NOT_COMPATIBLE): return "V2X_ERR_SRV_ID_L2_ADDRS_NOT_COMPATIBLE";
            case static_cast< int32_t>(Literal::V2X_ERR_PORT_UNAVAIL): return "V2X_ERR_PORT_UNAVAIL";
            case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_INVAL_PROFILE_FAMILY): return "DS_PROFILE_3GPP_INVAL_PROFILE_FAMILY";
            case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_ACCESS_ERR): return "DS_PROFILE_3GPP_ACCESS_ERR";
            case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_CONTEXT_NOT_DEFINED): return "DS_PROFILE_3GPP_CONTEXT_NOT_DEFINED";
            case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_VALID_FLAG_NOT_SET): return "DS_PROFILE_3GPP_VALID_FLAG_NOT_SET";
            case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_READ_ONLY_FLAG_SET): return "DS_PROFILE_3GPP_READ_ONLY_FLAG_SET";
            case static_cast< int32_t>(Literal::DS_PROFILE_3GPP_ERR_OUT_OF_PROFILES): return "DS_PROFILE_3GPP_ERR_OUT_OF_PROFILES";
            case static_cast< int32_t>(Literal::DS_PROFILE_3GPP2_ERR_INVALID_IDENT_FOR_PROFILE): return "DS_PROFILE_3GPP2_ERR_INVALID_IDENT_FOR_PROFILE";
            case static_cast< int32_t>(Literal::DS_PROFILE_3GPP2_ERR_OUT_OF_PROFILE): return "DS_PROFILE_3GPP2_ERR_OUT_OF_PROFILE";
            case static_cast< int32_t>(Literal::INTERNAL_ERROR): return "INTERNAL_ERROR";
            case static_cast< int32_t>(Literal::SERVICE_ERROR): return "SERVICE_ERROR";
            case static_cast< int32_t>(Literal::TIMEOUT_ERROR): return "TIMEOUT_ERROR";
            case static_cast< int32_t>(Literal::EXTENDED_ERROR): return "EXTENDED_ERROR";
            case static_cast< int32_t>(Literal::PORT_NOT_OPEN_ERROR): return "PORT_NOT_OPEN_ERROR";
            case static_cast< int32_t>(Literal::MEMCOPY_ERROR): return "MEMCOPY_ERROR";
            case static_cast< int32_t>(Literal::INVALID_TRANSACTION): return "INVALID_TRANSACTION";
            case static_cast< int32_t>(Literal::ALLOCATION_FAILURE): return "ALLOCATION_FAILURE";
            case static_cast< int32_t>(Literal::TRANSPORT_ERROR): return "TRANSPORT_ERROR";
            case static_cast< int32_t>(Literal::PARAM_ERROR): return "PARAM_ERROR";
            case static_cast< int32_t>(Literal::INVALID_CLIENT): return "INVALID_CLIENT";
            case static_cast< int32_t>(Literal::FRAMEWORK_NOT_READY): return "FRAMEWORK_NOT_READY";
            case static_cast< int32_t>(Literal::INVALID_SIGNAL): return "INVALID_SIGNAL";
            case static_cast< int32_t>(Literal::TRANSPORT_BUSY_ERROR): return "TRANSPORT_BUSY_ERROR";
            case static_cast< int32_t>(Literal::SUBSYSTEM_UNAVAILABLE): return "SUBSYSTEM_UNAVAILABLE";
            case static_cast< int32_t>(Literal::OPERATION_TIMEOUT): return "OPERATION_TIMEOUT";
            case static_cast< int32_t>(Literal::ROLLBACK_FAILED): return "ROLLBACK_FAILED";
            case static_cast< int32_t>(Literal::ROT_ALREADY_SET): return "ROT_ALREADY_SET";
            case static_cast< int32_t>(Literal::UNSUPPORTED_PURPOSE): return "UNSUPPORTED_PURPOSE";
            case static_cast< int32_t>(Literal::INCOMPATIBLE_PURPOSE): return "INCOMPATIBLE_PURPOSE";
            case static_cast< int32_t>(Literal::UNSUPPORTED_ALGO): return "UNSUPPORTED_ALGO";
            case static_cast< int32_t>(Literal::INCOMPATIBLE_ALGO): return "INCOMPATIBLE_ALGO";
            case static_cast< int32_t>(Literal::UNSUPPORTED_KEY_SIZE): return "UNSUPPORTED_KEY_SIZE";
            case static_cast< int32_t>(Literal::UNSUPPORTED_BLOCK_MODE): return "UNSUPPORTED_BLOCK_MODE";
            case static_cast< int32_t>(Literal::INCOMPATIBLE_BLOCK_MODE): return "INCOMPATIBLE_BLOCK_MODE";
            case static_cast< int32_t>(Literal::UNSUPPORTED_MAC_LEN): return "UNSUPPORTED_MAC_LEN";
            case static_cast< int32_t>(Literal::UNSUPPORTED_PADDING_MODE): return "UNSUPPORTED_PADDING_MODE";
            case static_cast< int32_t>(Literal::UNSUPPORTED_DIGEST): return "UNSUPPORTED_DIGEST";
            case static_cast< int32_t>(Literal::INCOMPATIBLE_DIGEST): return "INCOMPATIBLE_DIGEST";
            case static_cast< int32_t>(Literal::INVAL_EXP_TIME): return "INVAL_EXP_TIME";
            case static_cast< int32_t>(Literal::INVAL_USR_ID): return "INVAL_USR_ID";
            case static_cast< int32_t>(Literal::INVAL_AUTH_TIMEOUT): return "INVAL_AUTH_TIMEOUT";
            case static_cast< int32_t>(Literal::UNSUPPORTED_KEY_FMT): return "UNSUPPORTED_KEY_FMT";
            case static_cast< int32_t>(Literal::INCOMPATIBLE_KEY_FMT): return "INCOMPATIBLE_KEY_FMT";
            case static_cast< int32_t>(Literal::UNSUPPORTED_KEY_ENC_ALGO): return "UNSUPPORTED_KEY_ENC_ALGO";
            case static_cast< int32_t>(Literal::UNSUPPORTED_KEY_VRFY_ALGO): return "UNSUPPORTED_KEY_VRFY_ALGO";
            case static_cast< int32_t>(Literal::INVAL_IN_LEN): return "INVAL_IN_LEN";
            case static_cast< int32_t>(Literal::INVAL_KEY_EXPRT_OPTNS): return "INVAL_KEY_EXPRT_OPTNS";
            case static_cast< int32_t>(Literal::DELEGATION_NOT_ALLOWED): return "DELEGATION_NOT_ALLOWED";
            case static_cast< int32_t>(Literal::KEY_NOT_YET_VALID): return "KEY_NOT_YET_VALID";
            case static_cast< int32_t>(Literal::KEY_EXPIRED): return "KEY_EXPIRED";
            case static_cast< int32_t>(Literal::KEY_USR_NOT_AUTHENTICATED): return "KEY_USR_NOT_AUTHENTICATED";
            case static_cast< int32_t>(Literal::OUT_PARAMETER_NULL): return "OUT_PARAMETER_NULL";
            case static_cast< int32_t>(Literal::INVAL_OPERATION_HNDL): return "INVAL_OPERATION_HNDL";
            case static_cast< int32_t>(Literal::INSUFFICIENT_BUF_SPACE): return "INSUFFICIENT_BUF_SPACE";
            case static_cast< int32_t>(Literal::VERIFICATION_FAILED): return "VERIFICATION_FAILED";
            case static_cast< int32_t>(Literal::TOO_MANY_OPS): return "TOO_MANY_OPS";
            case static_cast< int32_t>(Literal::UNEXPECTED_NULL_PTR): return "UNEXPECTED_NULL_PTR";
            case static_cast< int32_t>(Literal::INVAL_KEY_BLOB): return "INVAL_KEY_BLOB";
            case static_cast< int32_t>(Literal::IMPORTED_KEY_NOT_ENC): return "IMPORTED_KEY_NOT_ENC";
            case static_cast< int32_t>(Literal::IMPORTED_KEY_DEC_FAIL): return "IMPORTED_KEY_DEC_FAIL";
            case static_cast< int32_t>(Literal::IMPORTED_KEY_NOT_SIGNED): return "IMPORTED_KEY_NOT_SIGNED";
            case static_cast< int32_t>(Literal::IMPORTED_KEY_VRFY_FAIL): return "IMPORTED_KEY_VRFY_FAIL";
            case static_cast< int32_t>(Literal::UNSUPPORTED_TAG): return "UNSUPPORTED_TAG";
            case static_cast< int32_t>(Literal::INVAL_TAG): return "INVAL_TAG";
            case static_cast< int32_t>(Literal::IMPORT_PARAM_MISMATCH): return "IMPORT_PARAM_MISMATCH";
            case static_cast< int32_t>(Literal::SEC_HW_ACCESS_DENIED): return "SEC_HW_ACCESS_DENIED";
            case static_cast< int32_t>(Literal::CONCUR_ACCESS_CONFLICT): return "CONCUR_ACCESS_CONFLICT";
            case static_cast< int32_t>(Literal::SEC_HW_BUSY): return "SEC_HW_BUSY";
            case static_cast< int32_t>(Literal::SEC_HW_COM_FAIL): return "SEC_HW_COM_FAIL";
            case static_cast< int32_t>(Literal::UNSUPPORTED_EC_FIELD): return "UNSUPPORTED_EC_FIELD";
            case static_cast< int32_t>(Literal::MISSING_NONCE): return "MISSING_NONCE";
            case static_cast< int32_t>(Literal::INVAL_NONCE): return "INVAL_NONCE";
            case static_cast< int32_t>(Literal::MISSING_MAC_LEN): return "MISSING_MAC_LEN";
            case static_cast< int32_t>(Literal::KEY_RATE_LIMIT_EXCEEDED): return "KEY_RATE_LIMIT_EXCEEDED";
            case static_cast< int32_t>(Literal::CALLER_NONCE_PROHIBITED): return "CALLER_NONCE_PROHIBITED";
            case static_cast< int32_t>(Literal::KEY_MAX_OPS_EXCEEDED): return "KEY_MAX_OPS_EXCEEDED";
            case static_cast< int32_t>(Literal::INVAL_MAC_LEN): return "INVAL_MAC_LEN";
            case static_cast< int32_t>(Literal::MISSING_MIN_MAC_LEN): return "MISSING_MIN_MAC_LEN";
            case static_cast< int32_t>(Literal::UNSUPPORTED_MIN_MAC_LEN): return "UNSUPPORTED_MIN_MAC_LEN";
            case static_cast< int32_t>(Literal::UNSUPPORTED_KDF): return "UNSUPPORTED_KDF";
            case static_cast< int32_t>(Literal::UNSUPPORTED_EC_CURVE): return "UNSUPPORTED_EC_CURVE";
            case static_cast< int32_t>(Literal::KEY_REQ_UPGRADE): return "KEY_REQ_UPGRADE";
            case static_cast< int32_t>(Literal::ATTESTATION_CHLNG_MIS): return "ATTESTATION_CHLNG_MIS";
            case static_cast< int32_t>(Literal::KM_NOT_CONFGRD): return "KM_NOT_CONFGRD";
            case static_cast< int32_t>(Literal::ATTESTATION_APPID_MIS): return "ATTESTATION_APPID_MIS";
            case static_cast< int32_t>(Literal::CANNOT_ATTEST_IDS): return "CANNOT_ATTEST_IDS";
            case static_cast< int32_t>(Literal::UNIMPLEMENTED): return "UNIMPLEMENTED";
            case static_cast< int32_t>(Literal::VER_MISMATCH): return "VER_MISMATCH";
            case static_cast< int32_t>(Literal::SOTER_ERR): return "SOTER_ERR";
            case static_cast< int32_t>(Literal::DMA_ERR): return "DMA_ERR";
            case static_cast< int32_t>(Literal::DIV_ERR): return "DIV_ERR";
            case static_cast< int32_t>(Literal::OVERFLOW_UNDERFLOW): return "OVERFLOW_UNDERFLOW";
            case static_cast< int32_t>(Literal::RNG_UNSEEDED): return "RNG_UNSEEDED";
            case static_cast< int32_t>(Literal::MEM_ERR): return "MEM_ERR";
            case static_cast< int32_t>(Literal::MODULUS_ERR): return "MODULUS_ERR";
            case static_cast< int32_t>(Literal::DECODING_ERR): return "DECODING_ERR";
            case static_cast< int32_t>(Literal::INVALID_LENGTH): return "INVALID_LENGTH";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct ServiceStatus : CommonAPI::Enumeration< int32_t> {
        enum Literal : int32_t {
            SERVICE_UNAVAILABLE = 0,
            SERVICE_AVAILABLE = 1,
            SERVICE_FAILED = 2
        };
    
        ServiceStatus()
            : CommonAPI::Enumeration< int32_t>(static_cast< int32_t>(Literal::SERVICE_UNAVAILABLE)) {}
        ServiceStatus(Literal _literal)
            : CommonAPI::Enumeration< int32_t>(static_cast< int32_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< int32_t>(Literal::SERVICE_UNAVAILABLE):
                case static_cast< int32_t>(Literal::SERVICE_AVAILABLE):
                case static_cast< int32_t>(Literal::SERVICE_FAILED):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const ServiceStatus &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const ServiceStatus &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const ServiceStatus &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const ServiceStatus &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const ServiceStatus &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const ServiceStatus &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< int32_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< int32_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< int32_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< int32_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< int32_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< int32_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< int32_t>(Literal::SERVICE_UNAVAILABLE): return "SERVICE_UNAVAILABLE";
            case static_cast< int32_t>(Literal::SERVICE_AVAILABLE): return "SERVICE_AVAILABLE";
            case static_cast< int32_t>(Literal::SERVICE_FAILED): return "SERVICE_FAILED";
            default: return "UNDEFINED";
            }
        }
    };
};

const char* CommonDefines::getInterface() {
    return ("commonapi.telux.common.CommonDefines:v1_0");
}

CommonAPI::Version CommonDefines::getInterfaceVersion() {
    return CommonAPI::Version(1, 0);
}


} // namespace common
} // namespace telux
} // namespace commonapi
} // namespace v1

namespace CommonAPI {
}


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_COMMON_COMMON_DEFINES_HPP_
